using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Collections;

namespace PowerAllocation
{
    public partial class ExistingPowerAllocation : Form
    {

        int ErrAt;
        int ReSend = 0;
        string Temp, MsgStatus,OldFileName,NewFileName;
        int cntt, tot, a, FileInfoCount, intNode, counter;
        byte[] NewFileArray;
        ArrayList cmbList = new ArrayList();
        string[] lst2cmb = { "1-2","1-4","2-1","2-3","2-5","3-2","4-1","4-5","4-7","3-2","3-6","5-2","5-4"
                                ,"5-6","5-8","6-5","6-3","7-4","7-8","8-7","8-5","8-9","9-6","9-8"};

        string[] lst3cmd ={"1-2-3","1-2-4","1-4-5","1-4-7","2-1-4","2-3-6","2-5-4","2-5-6","3-2-1","3-6-5",
                                "3-6-9","4-1-2","4-5-6","4-5-2","4-7-8","5-2-1","5-2-3","5-4-1","5-4-7","5-6-3","5-6-9",
                                "5-8-7","5-8-9","6-3-2","6-5-2","6-5-4","6-9-8","7-4-1","7-4-5","7-8-5","7-8-9","8-5-4",
                                "8-5-2","8-5-6","8-7-4","8-9-6","9-6-3","9-6-5","9-8-5","9-8-7"};
        bool isResend = false;
        byte[] TrxData, TrxData_new;

        public ExistingPowerAllocation()
        {
            InitializeComponent();
        }

        private void ExistingPowerAllocation_Load(object sender, EventArgs e)
        {
            GetCom();

            cmbTx.DropDownStyle = ComboBoxStyle.DropDownList;
            cmbReciver.DropDownStyle = ComboBoxStyle.DropDownList;
            cmbTx.SelectedIndex = 0;
            cmbReciver.SelectedIndex = 0;
            SetVisibility_Browse(false);
            SetVisibility_ReSend(false);
        }

        private void GetCom()
        {

            for (int i = 0; i < lst2cmb.Length - 1; i++)
            {
                cmbList.Add(lst2cmb[i].ToString());
                for (int j = 0; j < lst3cmd.Length - 1; j++)
                {
                    cmbList.Add(lst3cmd[j].ToString());

                    cmbList.Add(lst2cmb[i].ToString() + "-" + lst3cmd[j].ToString());
                }
            }
        }

        private void SetVisibility_Browse(bool visibile)
        {
            btnBrowse_1.Visible = visibile;
            btnBrowse_2.Visible = visibile;
            btnBrowse_3.Visible = visibile;
            btnBrowse_4.Visible = visibile;
            btnBrowse_5.Visible = visibile;
            btnBrowse_6.Visible = visibile;
            btnBrowse_7.Visible = visibile;
            btnBrowse_8.Visible = visibile;
            btnBrowse_9.Visible = visibile;
        }

        private void SetVisibility_ReSend(bool visibile)
        {
            btnResend_1.Visible = visibile;
            btnResend_2.Visible = visibile;
            btnResend_3.Visible = visibile;
            btnResend_4.Visible = visibile;
            btnResend_5.Visible = visibile;
            btnResend_6.Visible = visibile;
            btnResend_7.Visible = visibile;
            btnResend_8.Visible = visibile;
            btnResend_9.Visible = visibile;
        }

        private void btnBrowse_1_Click(object sender, EventArgs e)
        {
            ofdOpenFile.ShowDialog();
             
        }

        private void btnResend_1_Click(object sender, EventArgs e)
        {
            ofdOpenFile.ShowDialog();
            NewFileName = ofdOpenFile.FileName.ToString();
            if (NewFileName == OldFileName)
            {
                ReSend = 1;
                ReviveFile(TrxData);
            }
            else
            {
                MessageBox.Show("Files Mis-match. Please Choose previously selected File.");
            }
        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            if (Validate())
            {
                OldFileName = ofdOpenFile.FileName.ToString();
                TrxData = ConverFileToByteArray(ofdOpenFile.FileName);
                ReviveFile(TrxData);
            }
        }

        private bool Validate()
        {
            try
            {
                bool isNumber = false;
                int outputvalue = 0;
                isNumber = int.TryParse(txtPath.Text, out outputvalue);
                if (cmbTx.SelectedIndex == 0)
                {
                    MessageBox.Show("Please Select the Transmitter", "Power Allocation", MessageBoxButtons.OK);
                    return false;
                }
                else if (cmbReciver.SelectedIndex == 0)
                {
                    MessageBox.Show("Please Select the Reciver", "Power Allocation", MessageBoxButtons.OK);
                    return false;
                }
                else if (cmbTx.SelectedIndex == cmbReciver.SelectedIndex)
                {
                    MessageBox.Show("The Tranmitter and Reciver Should not be same", "Power Allocation", MessageBoxButtons.OK);
                    return false;
                }
                else if (txtPath.Text.ToString().Length == 0)
                {
                    MessageBox.Show("Please enter the Path", "Power Allocation", MessageBoxButtons.OK);
                    return false;
                }
                //else if (!isNumber)
                //{
                //    MessageBox.Show("Please enter the Correct Path", "Power Allocation", MessageBoxButtons.OK);
                //    return false;
                //}
                else if (ofdOpenFile.FileName.ToString().Length == 0)
                {
                    MessageBox.Show("Please Browse the any File", "Power Allocation", MessageBoxButtons.OK);
                    return false;
                }
                return true;
            }
            catch
            {
                return false;
            }
        }


        private void ReviveFile(byte[] ReciveFile)
        {
            try
            {
                string strPath = txtPath.Text;
                string[] node = strPath.Split('-');
                #region ranjith
                if (node.Length >= 2 && ReSend == 0)
                    ErrAt = Convert.ToInt32(node[1]);
                else
                    ErrAt = 0;
                counter = 0;
                NewFileArray = new byte[ReciveFile.Length];
                for (int i = 0; i < ReciveFile.Length - 1; i++)
                {
                    Temp = ReciveFile[i].ToString();
                    FileInfoCount = ErrMsg(Temp.Length, Temp);
                    if (FileInfoCount != ErrAt)
                    {
                        NewFileArray[counter] = ReciveFile[i];
                        counter++;
                    }
                }
                if (counter != 0 && ReSend != 1)
                {
                    //intNode = Convert.ToInt32(node[1]);
                    for (intNode = 0; intNode < node.Length; intNode++)
                    {
                        if (Convert.ToInt32(node[intNode]) == ErrAt)
                        {
                            SetVisibilitytoReSend(Convert.ToString(node[intNode]));
                            ApplyColor("#AF1E2D", false, Convert.ToString(node[intNode]));

                        }
                        else
                        {
                            ApplyColor("#5EDA9E", false, Convert.ToString(node[intNode]));

                        }


                    }

                    MsgStatus = "File Corrupted while Transferring via Node " + Convert.ToString(node[1]) + " . Please Re-send the same File.";
                    MessageBox.Show(MsgStatus);
                }
                else
                {
                    for (intNode = 0; intNode < node.Length; intNode++)
                    {
                        ApplyColor("#5EDA9E", false, Convert.ToString(node[intNode]));
                    }
                    MsgStatus = "File Received Successfully. ";
                    DialogResult result;
                    result = MessageBox.Show(MsgStatus + " Do you want to save the file", "Power Allocation", MessageBoxButtons.YesNo, MessageBoxIcon.Information);
                    if (result == DialogResult.Yes)
                    {
                        sfdSaveRecivedFile.ShowDialog();
                        writeByteArrayToFile(ReciveFile, sfdSaveRecivedFile.FileName);
                    }

                }
                #endregion
                #region OldCoding
                //for (intNode = 0; intNode < node.Length - 1; intNode++)
                //{


                // This is the place need to be transfer the bye array to one node to another node 

                //if (!isResend)
                //{
                //    if ((ReciveFile.Length < 100) || (ReciveFile.Length > 200))
                //    {
                //        isResend = true;
                //        ApplyColor("#AF1E2D", false, node[intNode]);
                //        SetVisibilitytoReSend(node[intNode]);
                //        return;
                //    }
                //    else

                //        ApplyColor("#5EDA9E", false, node[intNode]);

                //}
                //else
                //{
                //    ApplyColor("#5EDA9E", false, node[intNode]);
                //}


                //}
                #endregion

                #region ranjith



                #endregion
                

            }
            catch
            {

            }
        }

        public bool writeByteArrayToFile(byte[] buff, string fileName)
        {
            bool response = false;

            try
            {
                FileStream fs = new FileStream(fileName, FileMode.Create, FileAccess.ReadWrite);
                BinaryWriter bw = new BinaryWriter(fs);
                bw.Write(buff);
                bw.Close();
                response = true;
            }
            catch
            {

            }

            return response;
        }

        private int ErrMsg(int len, string str)
        {
            cntt = 0;
            for (int i = 0; i < len; i++)
            {
                if (i != len)
                {
                    a = Convert.ToInt32(str.Substring(i, 1));
                    tot = cntt + a;
                    cntt = tot;
                }
            }
            if (Convert.ToString(cntt).Length > 1)
                tot = Convert.ToInt32(Convert.ToString(cntt).Substring(0, 1)) + Convert.ToInt32(Convert.ToString(cntt).Substring(1, 1));
            else
                tot = cntt;

            return tot;
        }

        private void ApplyColor(string BackColor, bool isReSet, string node)
        {
            try
            {
                foreach (Control ctrl in grpPowerAllocation.Controls)
                {
                    if (!isReSet)
                    {

                        if (node == "0")
                        {
                            if (ctrl.Name == "pnlTxReciver" + cmbReciver.SelectedIndex)
                            {
                                ctrl.BackColor = System.Drawing.ColorTranslator.FromHtml(BackColor);
                            }
                        }
                        else if (ctrl.Name == "pnlTxReciver" + node)
                        {
                            ctrl.BackColor = System.Drawing.ColorTranslator.FromHtml(BackColor);
                        }

                    }
                    else
                    {
                        if (ctrl.Name.Contains("pnlTxReciver"))
                        {
                            ctrl.BackColor = System.Drawing.ColorTranslator.FromHtml(BackColor);
                        }
                    }

                }
            }
            catch
            {

            }
        }

        private void SetVisibilitytoReSend(string node)
        {
            if (node == "1")
            {
                SetVisibility_ReSend(false);
                btnResend_1.Visible = true;
            }
            else if (node == "2")
            {
                SetVisibility_ReSend(false);
                btnResend_2.Visible = true;
            }
            else if (node == "3")
            {
                SetVisibility_ReSend(false);
                btnResend_3.Visible = true;
            }
            else if (node == "4")
            {
                SetVisibility_ReSend(false);
                btnResend_4.Visible = true;
            }
            else if (node == "5")
            {
                SetVisibility_ReSend(false);
                btnResend_5.Visible = true;
            }
            else if (node == "6")
            {
                SetVisibility_ReSend(false);
                btnResend_6.Visible = true;
            }
            else if (node == "7")
            {
                SetVisibility_ReSend(false);
                btnResend_7.Visible = true;
            }
            else if (node == "8")
            {
                SetVisibility_ReSend(false);
                btnResend_8.Visible = true;
            }
            else if (node == "9")
            {
                SetVisibility_ReSend(false);
                btnResend_9.Visible = true;
            }

        }


        
        private byte[] ConverFileToByteArray(string filename)
        {
            try
            {
                FileStream fs = new FileStream(filename, FileMode.Open, FileAccess.Read);
                byte[] FileData = new byte[fs.Length];
                fs.Read(FileData, 0, System.Convert.ToInt32(fs.Length));
                fs.Close();
                return FileData;

            }
            catch
            {
                return null;
            }

        }

        private void cmbTx_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cmbTx.SelectedIndex == 1)
            {
                SetVisibility_Browse(false);
                btnBrowse_1.Visible = true;
            }
            else if (cmbTx.SelectedIndex == 2)
            {
                SetVisibility_Browse(false);
                btnBrowse_2.Visible = true;
            }
            else if (cmbTx.SelectedIndex == 3)
            {
                SetVisibility_Browse(false);
                btnBrowse_3.Visible = true;
            }
            else if (cmbTx.SelectedIndex == 4)
            {
                SetVisibility_Browse(false);
                btnBrowse_4.Visible = true;
            }
            else if (cmbTx.SelectedIndex == 5)
            {
                SetVisibility_Browse(false);
                btnBrowse_5.Visible = true;
            }
            else if (cmbTx.SelectedIndex == 6)
            {
                SetVisibility_Browse(false);
                btnBrowse_6.Visible = true;
            }
            else if (cmbTx.SelectedIndex == 7)
            {
                SetVisibility_Browse(false);
                btnBrowse_7.Visible = true;
            }
            else if (cmbTx.SelectedIndex == 8)
            {
                SetVisibility_Browse(false);
                btnBrowse_8.Visible = true;
            }
            else if (cmbTx.SelectedIndex == 9)
            {
                SetVisibility_Browse(false);
                btnBrowse_9.Visible = true;
            }
        }

        private void cmbReciver_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyColor("#CDAF95", true, "0");
        }

        private void btn_switch_Click(object sender, EventArgs e)
        {
            this.Hide();
            PwdAllocation adva = new PwdAllocation();
            adva.Show();
        }
         
    }
}